<template>
    <div>
        <form @submit.prevent="handleLogin" method="post">

            <label for="username">Username or Email</label>

            <div>
                <p>
                    <input v-model="username" name="username" type="text" placeholder="Username"/>
                </p>
            </div>

            <label for="password">Password</label>
            <div>
                <p>
                    <input v-model="password" name="password" type="password"/>
                </p>
            </div>

            <button>
                <span>Login</span>
            </button>

            <div>{{ message }}</div>

        </form>


        <ul>
            <li><router-link to="/secured">Content for user</router-link></li>
            <li><router-link to="/admin">Content for admin</router-link></li>
        </ul>
    </div>

</template>

<script lang="ts">

import {useAuth} from "@/store/auth.store";

export default defineComponent({
    data() {
        return {
            message : "",
            username: "",
            password: "",
        }
    },
    created() {
        let store = useAuth();
        store.isLogged().then(isLogged => {
            if (isLogged) {
                this.$router.push("/secured");
            }
        });
    },
    methods: {
        handleLogin(user) {
            let store = useAuth();
            store.login(this.username, this.password).then(
                () => {
                    this.$router.push("/secured");
                },
                (error) => {
                    this.message =
                        (error.response &&
                            error.response.data &&
                            error.response.data.message) ||
                        error.message ||
                        error.toString();
                }
            );
        },
    },
})


</script>
